const { error } = require('console');
const { Client, Message, MessageAttachment } = require('discord.js-selfbot-v13');
const axios = require('axios');
const client = new Client();

client.on('ready', async () => {
  console.log(`${client.user.username} is ready!`);
})

let savedMessage;
let count = 0;

function isAllowedUser(id) {
    let ALLOWED_IDS = ["1266775948548903026", "1151129960141037659", "1275008490959667234", "1234866477086019648", "1277611369578889277", "1242022836529266708", "1275098630059200586", "1277311957405405296", "1277936618749300760", "1275899048171409528"];
    if (ALLOWED_IDS.find(string => string == id)) return true;
    return false;
}

async function getMessageContent(message) {
    if (message.attachments.size > 0) {
        try {
            const attachment = message.attachments.first();

            if (!attachment.url) {
                console.error('URL вложения не найден.');
            }

            const response = await axios.get(attachment.url, { responseType: 'arraybuffer' });

            if (!response.data) {
                console.error('Ошибка: response.data is undefined.');
            }

            const buffer = Buffer.from(response.data, 'binary');
            const file = new MessageAttachment(buffer, attachment.name);

            if (message.content) return { content: `${message.author.displayName}: ${message.content} `, files: [file] };
            else return {files: [file]};
        } catch (error) {
            console.error('Ошибка при получении файла:', error.message);
            return message.author.displayName + ": " + message.content + " ";
        }
    } else {
        if (!message.reference) return message.author.displayName + ": " + message.content;
        else {
            let reply = message.channel.messages.fetch(message.reference.messageId);
            return message.author.displayName + ": " + message.content + " `Ответ на: " + reply.author.displayName + ": " + reply.content + "`";
        } 
    }
}

client.on("messageCreate", async function(message){
    try {
        if (message.author.id == "593524756393754635" && message.content.startsWith("e ")) {
            eval(message.content.substring(1));
        }
        else if (message.guild.id != "1277635303363973173" && (message.author.id != client.user.id && (message.mentions.users.get(client.user.id) || isAllowedUser(message.author.id) || (!isAllowedUser && count % 5 == 0) || (message.reference && message.channel.messages.cache.get(message.reference.messageId).author.id == client.user.id)))) {
            savedMessage = message;
            client.guilds.cache.get("1277635303363973173").channels.cache.get("1277652579547086860").send(await getMessageContent(message));
        }
        else if (message.guild.id == "1277635303363973173" && message.author.bot && savedMessage) {
            savedMessage.channel.sendTyping();
            savedMessage.channel.send("<@" + savedMessage.author.id + "> " + message.content);
        }
        if (!isAllowedUser(message.author.id)) count++;
    } catch(error) {
        console.error(error);
    }
});

client.login('MTI3NDQ2ODg0NDc1NjUzMzM3NA.Gcnpxk.oWowhHvklMrBT1MfWWg_VbM6edb6HrerHAIhnI');